"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.slugify = exports.defaultCharmap = void 0;
const defaults = __importStar(require("./defaults"));
exports.defaultCharmap = defaults.charmap;
function slugify(str, options) {
    if (typeof options === 'string') {
        options = { whitespaceReplaceChar: options };
    }
    options ?? (options = {});
    options.charmap ?? (options.charmap = defaults.charmap);
    options.multiCharmap ?? (options.multiCharmap = defaults.multiCharmap);
    options.removeMultipleWhitespace ?? (options.removeMultipleWhitespace = true);
    options.trim ?? (options.trim = true);
    options.unidentifiedReplaceChar ?? (options.unidentifiedReplaceChar = defaults.unidentifiedReplaceChar);
    options.whitespaceReplaceChar ?? (options.whitespaceReplaceChar = defaults.whitespaceReplaceChar);
    options.whitespaces ?? (options.whitespaces = defaults.whitespaces);
    // Copy the charmap object so we do not screw up the original one
    const charmap = { ...options.charmap };
    // Convert input to string
    str = String(str);
    if (options.trim) {
        str = str.trim();
    }
    // Shorthand for saving characters
    if (options.save) {
        if (!Array.isArray(options.save)) {
            options.save = [options.save];
        }
        for (const saveChar of options.save) {
            charmap[saveChar] = saveChar;
        }
    }
    // Set whitespace characters that is not in the charmap
    // We do this since we'd like to handle explicit whitecharacters separately
    // from the charmap further down
    const whitespaces = [];
    for (const whitespace of options.whitespaces) {
        if (charmap[whitespace] === undefined) {
            whitespaces.push(whitespace);
        }
    }
    // Start with replacing multichars
    for (const searchChar of Object.keys(options.multiCharmap)) {
        str = str.split(searchChar).join(options.multiCharmap[searchChar]);
    }
    // Then replace all single characteres
    const strArr = str.split('');
    let prevWS = false;
    for (let i = 0; i < strArr.length; i++) {
        const thisStr = strArr[i];
        if (whitespaces.includes(thisStr)) {
            // Whitespace found!
            strArr[i] = prevWS && options.removeMultipleWhitespace ? '' : options.whitespaceReplaceChar;
            prevWS = true;
        }
        else {
            // No whitespace found
            strArr[i] = charmap[thisStr] ?? options.unidentifiedReplaceChar;
            // If the previous character was a whitespace and the current should be ignored, set prevWS to true again
            if (prevWS && charmap[thisStr] === undefined && options.unidentifiedReplaceChar === '') {
                prevWS = true;
            }
            else {
                prevWS = false;
            }
        }
    }
    const result = strArr.join('');
    return result;
}
exports.slugify = slugify;
//# sourceMappingURL=index.js.map